// WonceUpon.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	// TODO: Place code here.
	WORD year, month, day;
	char* pt;
	
	if (!(pt = strchr(lpCmdLine, ' '))) goto HELP;
	*pt = 0;
	year = atoi(lpCmdLine);
	lpCmdLine = pt + 1;
	
	if (!(pt = strchr(lpCmdLine, ' '))) goto HELP;
	*pt = 0;
	month = atoi(lpCmdLine);
	lpCmdLine = pt + 1;
	
	if (!(pt = strchr(lpCmdLine, ' '))) goto HELP;
	*pt = 0;
	day = atoi(lpCmdLine);
	lpCmdLine = pt + 1;
	
	{
		SYSTEMTIME onceupon;
		SYSTEMTIME now;
		
		onceupon.wYear = year;
		onceupon.wMonth = month;
		onceupon.wDay = day;
		onceupon.wHour = 0;
		onceupon.wMinute = 0;
		onceupon.wSecond = 0;
		onceupon.wMilliseconds = 0;
		
		GetLocalTime(&now);       // gets current time
		if (!SetLocalTime(&onceupon)){ //this will not apply new daylight saving if any
			MessageBox(NULL, "SetLocalTime(1) failed!\n", "ERROR", MB_OK);
			return 3;
		}
		CTime ct_now(now);
		CTime ct_onceupon(onceupon); //do not set dst to 0 or 1 manually!
		CTimeSpan ts = ct_now - ct_onceupon;
		
		
		STARTUPINFO stInfo;
		PROCESS_INFORMATION pInfo;
		GetStartupInfo(&stInfo);
		CreateProcess(NULL, lpCmdLine, NULL, NULL, 0,
			CREATE_NO_WINDOW | CREATE_DEFAULT_ERROR_MODE | NORMAL_PRIORITY_CLASS,
			NULL,
			NULL,
			&stInfo,
			&pInfo
			);
		
		//		system(cs); //this might take some time
		WaitForInputIdle(pInfo.hProcess, INFINITE);
		
		GetSystemTime(&now);
		ct_now = CTime(now) + ts;
		ct_now.GetAsSystemTime(now);
		if(!SetSystemTime(&now)){
			MessageBox(NULL, "SetSystemTime(2) failed!\n", "ERROR", MB_OK);
			return 4;
		}
	}
	return 0;
	
HELP:
	MessageBox(NULL, "WonceUpon year month day CmdLine_with_options", "Usage:", MB_OK);
	return 1;
}



